<?php
/**
 * Plugin : smiley tasks"
 *
 * Syntax: <TEST> - will be replaced with "Hello World!"
 * 
 * ~~NOCACHE~~ shall be use in the page in order to get the list updated
 *
 * @license    GPL 2 (http://www.gnu.org/licenses/gpl.html)
 * @author     Christopher Smith <chris@jalakai.co.uk>
 */
 
if(!defined('DOKU_INC')) die();
if(!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');
require_once(DOKU_PLUGIN.'syntax.php');
require ("smiley_wikitag_agregator.php");
require_once(DOKU_INC.'inc/init.php');
 
/**
 * All DokuWiki plugins to extend the parser/rendering mechanism
 * need to inherit from this class
 */
class syntax_plugin_smileytasks extends DokuWiki_Syntax_Plugin {
 
    function getInfo(){
        return array(
            'author' => 'fred',
            'email'  => 'fred31@free.fr',
            'date'   => '2008-11-03',
            'name'   => 'smiley tasks',
            'desc'   => 'using smiley to get a list of task or things',
            'url'    => 'http://lamaisonsimon.fr',
        );
    }
 
    function getType(){ return 'formatting'; }
    function getAllowedTypes() { return array('formatting', 'substition', 'disabled'); }

    
    function getSort(){ return 958; }
   /**
    * Connect lookup pattern to lexer.
    *
    * @param $aMode String The desired rendermode.
    * @return none
    * @public
    * @see render()
    */
    function connectTo($mode) {
      $this->Lexer->addSpecialPattern('list_tag>.*?@@',$mode,'plugin_smileytasks');
      //$this->Lexer->addEntryPattern('list_tag>(.*?)@@',$mode,'plugin_smileytasks'); 
    }
 
    //function postConnect() {$this->Lexer->addExitPattern('@@','plugin_smileytasks'); } 
 
   /**
    * Handler to prepare matched data for the rendering process.
    *
    * <p>
    * The <tt>$aState</tt> parameter gives the type of pattern
    * which triggered the call to this method:
    * </p>
    * <dl>
    * <dt>DOKU_LEXER_ENTER</dt>
    * <dd>a pattern set by <tt>addEntryPattern()</tt></dd>
    * <dt>DOKU_LEXER_MATCHED</dt>
    * <dd>a pattern set by <tt>addPattern()</tt></dd>
    * <dt>DOKU_LEXER_EXIT</dt>
    * <dd> a pattern set by <tt>addExitPattern()</tt></dd>
    * <dt>DOKU_LEXER_SPECIAL</dt>
    * <dd>a pattern set by <tt>addSpecialPattern()</tt></dd>
    * <dt>DOKU_LEXER_UNMATCHED</dt>
    * <dd>ordinary text encountered within the plugin's syntax mode
    * which doesn't match any pattern.</dd>
    * </dl>
    * @param $aMatch String The text matched by the patterns.
    * @param $aState Integer The lexer state for the match.
    * @param $aPos Integer The character position of the matched text.
    * @param $aHandler Object Reference to the Doku_Handler object.
    * @return Integer The current lexer state for the match.
    * @public
    * @see render()
    * @static
    */
    function handle($match, $state, $pos, &$handler){
        switch ($state) {
          case DOKU_LEXER_ENTER :   return array($state, $match);   
          break;
          case DOKU_LEXER_MATCHED :  return array($state, $match);
          break;
          case DOKU_LEXER_UNMATCHED : return array($state, $match);
          break;
          case DOKU_LEXER_EXIT :      return array($state, $match);
          break;
          case DOKU_LEXER_SPECIAL : 
                $pat=substr($match, 9, -2);                
                return array($state, $pat);          
          break;
        }
        return array();
    }
 
   /**
    * Handle the actual output creation.
    *
    * <p>
    * The method checks for the given <tt>$aFormat</tt> and returns
    * <tt>FALSE</tt> when a format isn't supported. <tt>$aRenderer</tt>
    * contains a reference to the renderer object which is currently
    * handling the rendering. The contents of <tt>$aData</tt> is the
    * return value of the <tt>handle()</tt> method.
    * </p>
    * @param $aFormat String The output format to generate.
    * @param $aRenderer Object A reference to the renderer object.
    * @param $aData Array The data created by the <tt>handle()</tt>
    * method.
    * @return Boolean <tt>TRUE</tt> if rendered successfully, or
    * <tt>FALSE</tt> otherwise.
    * @public
    * @see handle()
    */
    function render($mode, &$renderer, $data) {
	global $conf;
        if($mode == 'xhtml'){
          list($state,$tag) = $data;
          //var_dump($data);
          switch ($state) {
          case DOKU_LEXER_ENTER : 
            break;
          case DOKU_LEXER_MATCHED :
            break;
          case DOKU_LEXER_UNMATCHED : $renderer->doc .= $tag;
            break;
          case DOKU_LEXER_EXIT :  
            break;
          case DOKU_LEXER_SPECIAL : 
                   //$path="/homez.383/lamaisonecn/www/wiki/data/pages";        
                   $path=$conf['datadir'];
                   //echo "PATH datadir=".$conf['datadir']; //ne fonctionne pas ... si on ne declare pas $conf en global
                   list($tag,$title) = preg_split('/ /',$tag, 2);
                   $files= new smiley_wikitag_agregator("txt",$path); //create the class
                  //search recursively for TODO smiley
                   $taglist=$files->Getsmiley_wikitag($tag,true);
                   $tag = $files->Getrealpattern();
                   if ($title == ""){$title ="tag list of : ".$tag." at ".date("H:i:s");}                   
                   $title__ = str_replace(" ","_",$title);
                   //$out = "<h3><a name=\"".$title__."\" id=\"".$title__."\">".$title;                     
                   //$out .="</a></h3><div class=\"level3\">";
                   $out ="<TABLE class=\"inline\" ><tr class=\"row0\"><th class=\"col0 leftalign\">SHORT PATH</th><th class=\"col1 centeralign\">priorit&eacute</th><th class=\"col2 leftalign\">DESCRIPTION : ".$title."</th></tr>\n";
                   if (count($taglist)>0)
                   {                   
                     foreach ($taglist as $value)
                     {
                     //<a href="/doku.php?id=bricolage:travaux_maison" class="wikilink1" title="bricolage:travaux_maison">travaux_maison</a>
                       $out .="<tr class=\"row1\"><TD class=\"col0 leftalign\"><a href=\"/wiki/doku.php?id=".$value[PATH];
                       $out .="\"class=\"wikilink1\" title=\"".$value[PATH]."\">".str_replace(":"," :",$value[PATH])."</a></TD>";
                       $out .="<TD class=\"col1 centeralign\">".$value[PRIO]."</TD>";
                       $out .="<TD class=\"col2 leftalign\">".$value[DESCRIPTION]."</TD></tr>\n";
                     }
                   }
                   $out .="</TABLE>";
                   $renderer->doc .= $out;                                                                                      
            break;                             
          }
           return true;
        }
        return false;
    }
}
?>